=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2006-07-13 14:48:43 +0000
+++ bzrlib/option.py	2006-07-13 15:47:08 +0000
@@ -184,6 +184,12 @@
             if option is self:
                 return short
 
+    def get_negation_name(self):
+        if self.name.startswith('no-'):
+            return self.name[3:]
+        else:
+            return 'no-' + self.name
+
     def add_option(self, parser, short_name):
         """Add this option to an Optparse parser"""
         option_strings = ['--%s' % self.name]
@@ -195,6 +201,11 @@
                               help=self.help,
                               default=OptionParser.DEFAULT_VALUE,
                               *option_strings)
+            negation_strings = ['--%s' % self.get_negation_name()]
+            parser.add_option(action='store_const', dest=self.name, 
+                              help=optparse.SUPPRESS_HELP,
+                              const=OptionParser.DEFAULT_VALUE,
+                              *negation_strings)
         else:
             parser.add_option(action='callback', 
                               callback=self._optparse_callback, 

